Index: dll/3rdparty/mbedtls/CMakeLists.txt
===================================================================
--- dll/3rdparty/mbedtls/CMakeLists.txt	(revisión: 69439)
+++ dll/3rdparty/mbedtls/CMakeLists.txt	(copia de trabajo)
@@ -1,10 +1,11 @@
 
 spec2def(mbedtls.dll mbedtls.spec ADD_IMPORTLIB)
 
-include_directories(${REACTOS_SOURCE_DIR}/include/reactos/libs/mbedtls
+include_directories(${REACTOS_SOURCE_DIR}/include/reactos/libs
                     ${REACTOS_SOURCE_DIR}/include/reactos/zlib)
 
 list(APPEND src
+     _reactos_strsafe_wrapper.c
      aes.c
      aesni.c
      arc4.c
@@ -22,10 +23,10 @@
      debug.c
      des.c
      dhm.c
+     ecdh.c
+     ecdsa.c
      ecp.c
      ecp_curves.c
-     ecdh.c
-     ecdsa.c
      entropy.c
      entropy_poll.c
      error.c
@@ -32,23 +33,22 @@
      gcm.c
      havege.c
      hmac_drbg.c
-     md.c
-     md_wrap.c
      md2.c
      md4.c
      md5.c
+     md.c
+     md_wrap.c
      memory_buffer_alloc.c
      net.c
      oid.c
      padlock.c
-     pbkdf2.c
      pem.c
-     pkcs5.c
+     pk.c
      pkcs11.c
      pkcs12.c
-     pk.c
+     pkcs5.c
+     pkparse.c
      pk_wrap.c
-     pkparse.c
      pkwrite.c
      platform.c
      ripemd160.c
@@ -59,7 +59,9 @@
      ssl_cache.c
      ssl_ciphersuites.c
      ssl_cli.c
+     ssl_cookie.c
      ssl_srv.c
+     ssl_ticket.c
      ssl_tls.c
      threading.c
      timing.c
@@ -66,10 +68,10 @@
      version.c
      version_features.c
      x509.c
+     x509_create.c
+     x509_crl.c
      x509_crt.c
-     x509_crl.c
      x509_csr.c
-     x509_create.c
      x509write_crt.c
      x509write_csr.c
      xtea.c)
@@ -83,6 +85,10 @@
 target_link_libraries(mbedtls zlib)
 add_importlibs(mbedtls advapi32 ws2_32 msvcrt kernel32)
 
+# to use `_vsnprintf_s` looks like we have to define MINGW_HAS_SECURE_API
+# and explicitly export it from msvcrt for it to work... what on earth?!
+add_definitions(-DMINGW_HAS_SECURE_API -DCRTDLL)
+
 if(MSVC)
     add_importlibs(mbedtls ntdll)
 endif()
Index: dll/3rdparty/mbedtls/_reactos_strsafe_wrapper.c
===================================================================
--- dll/3rdparty/mbedtls/_reactos_strsafe_wrapper.c	(nonexistent)
+++ dll/3rdparty/mbedtls/_reactos_strsafe_wrapper.c	(copia de trabajo)
@@ -0,0 +1,50 @@
+/*
+ * Handy secure string adapter functions for mbedTLS,
+ * converting from `StringCchVPrintfEx` to `_vsnprintf_s`.
+ *
+ * Copyright 2015 Ismael Ferreras Morezuelas <swyterzone+ros@gmail.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#include <windef.h>
+#include <strsafe.h>
+
+int _vsnprintf_s(char *buffer, size_t sizeOfBuffer, size_t count, const char *format, va_list argptr)
+{
+    size_t cchRemaining;
+
+    HRESULT ret = StringCchVPrintfEx(buffer, sizeOfBuffer, NULL, &cchRemaining, 0, format, argptr);
+
+    // EXAMPLE //////////////////////////
+    // -------- > Size of provided buffer in chars (8).
+    // ABC0____ > Buffer contents after StringCchVPrintfEx gets called.
+    // ---      > What we actually need to return (3).
+    //    ----- > Remaining chars in buffer, including post string NULL, returned by StringCchVPrintfEx (5).
+
+    /* _vsnprintf_s returns the number of characters written, not including
+       the terminating null, or a negative value if an output error occurs.  */
+
+    switch (ret)
+    {
+        case S_OK:
+            return (sizeOfBuffer - cchRemaining);
+
+        case STRSAFE_E_INVALID_PARAMETER:
+        case STRSAFE_E_INSUFFICIENT_BUFFER:
+        default:
+            return -1;
+    }
+}
\ No newline at end of file
